-- This file is part of Bindings-bfd.
--
-- Copyright (C) 2010,2011 Mick Nelso
--
-- Bindings-bfd is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Lesser General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- Bindings-bfd is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Lesser General Public License for more details.

-- You should have received a copy of the GNU Lesser General Public License
-- along with Bindings-bfd.  If not, see <http://www.gnu.org/licenses/>.

module Bindings.Bfd (
     Bfd(ptr)
   , Bfd'
   , Bindings.Bfd.mk
   , getOctetsPerByte
   , getTarget
   , getSections
) where

import Foreign.C
import Foreign.Ptr
import Foreign.Storable

import {-# SOURCE #-} Bindings.Bfd.Section
import {-# SOURCE #-} Bindings.Bfd.Target


data Bfd = Bfd {
                ptr      :: Ptr Bfd'
              , filePath :: CString
              , target   :: CString
              , mode     :: CString
           }

instance Show Bfd


data Bfd'

instance Storable Bfd'


mk
   :: Ptr Bfd'
   -> Bfd

getOctetsPerByte
   :: Bfd
   -> IO Int

getTarget
   :: Bfd
   -> IO Target

getSections
   :: Bfd
   -> IO [Section]

